<?php
/*
VideoWhisper Video Conference Integration (for Joomla):

Copyright (C) 2009  VideoWhisper.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

header('Cache-Control: no-cache');
header('Pragma: no-cache');
setcookie("videowhisper_com",time(),time()+3600);

jimport( 'joomla.application.component.model' );

class VwModelFlash extends JModel
{
    function getOutput($task)
	{


	function hasrights($username, $usertype, $owner, $rights)
	{
		if (trim($rights)=="None") return 0;

		$rightslist=explode(",",$rights);
		foreach ($rightslist as $key => $value) $rightslist[$key]=trim($rightslist[$key]);

		if (in_array("All",$rightslist)) return 1;
		if (in_array($username,$rightslist)) return 1;
		if (in_array($usertype,$rightslist)) return 1;
		if (in_array("Admins",$rightslist) && (in_array($usertype, array('Super Administrator', 'Administrator', 'Manager')) || ($username==$owner&&$username))) return 1;
		if (in_array("Members",$rightslist) && $username) return 1;
		return 0;
	}

	function not($n)
    {
    if ($n) return 0; else return 1;
    }

  	$params = &JComponentHelper::getParams( 'com_videowhisper_conference' );
	$rtmp_server=$params->get( 'rtmp' );
	$show_tutorial=$params->get( 'show_tutorial');
	$landing_room=$params->get( 'landing_room');


	$welcome_room=urlencode($params->get( 'welcome_room'));
	$welcome_message=urlencode($params->get( 'welcome_message'));
	$allow_fileupload=$params->get( 'allow_fileupload');
	$allow_filedelete=$params->get( 'allow_filedelete');

	$path="components/com_videowhisper_conference/";

  //connect to joomla database
  $db =& JFactory::getDBO();

	switch ($task)
	{
	case "login":
	//room cleanups
	$ztime=time();
	$query = "UPDATE #__vw_rooms SET timelastaccess=timecreated where timelastaccess=0";
	$db->setQuery( $query );
  	$db->query();

	$query = "DELETE FROM #__vw_rooms WHERE (( timeexpire > 0) AND ((timeexpire*86400 + timecreated) < $ztime)) OR ((timeout > 0) AND ( ($ztime-timelastaccess) > (timeout * 3600)))";
    $db->setQuery( $query );
  	$db->query();

	//credit reset
	$query = "UPDATE #__vw_rooms SET creditslastreset=$ztime, timeused=0 WHERE (creditsreset > 0) AND (( $ztime - creditslastreset) > (creditsreset *86400))";
	$db->setQuery( $query );
	$db->query();

	//get room
	$room_name=JRequest::getVar( 'room_name' );
	if (!$room_name) $room_name=$landing_room;

	$sql="SELECT * FROM #__vw_rooms WHERE room='$room_name'";
	$db->setQuery( $sql );
	$room = $db->loadObject();
	if (!$room)
	{
		$message="<a href=\"/\">Room '$room_name' does not exist. Contact administrator!</a>";
		$loggedin=0;
	}
	else
	{
	$owner=$room->owner;

	$user =& JFactory::getUser();
	if (!$user->get('id')) $loggedin=0; else $loggedin=1;
	if (!$loggedin&&!$room->visitors) $message="<a href=\"/\">Please login to your account first (on member frontend)!</a>";
	$username=$user->get('name');
	$usertype=$user->usertype;

	//room parameters
	$allow_fileupload=hasrights($username, $usertype, $owner, $room->mfilesu);
	$allow_filedelete=hasrights($username, $usertype, $owner, $room->mfilesd);
	$administrator=hasrights($username, $usertype, $owner, $room->admins);
 	$cam_source=hasrights($username, $usertype, $owner, $room->mcsource);
 	$cam_novideo=not(hasrights($username, $usertype, $owner, $room->mcvideo));
 	$cam_nosound=not(hasrights($username, $usertype, $owner, $room->mcsound));
	$showcredit=hasrights($username, $usertype, $owner, $room->showcredit);
    $filterRegex=urlencode($room->filter);
    $filterReplace=urlencode($room->freplace);
	if ($room->rtmp) $rtmp_server=$room->rtmp;
	$cam=explode("x", $room->camres);

	//visitor?
	$visitor=0;
	if (!$loggedin&&$room->visitors)
	{
		$loggedin=1;
		$username="Guest".rand(0,10000);
		$usertype="Guest";
		$visitor=1;
	}

	//enabled
	if ($room->suspended)
	{
		$message="<a href=\"/\">Room '$room_name' is suspended!</a>";
		$loggedin=0;
		$visitor=0;
	}

	//rtmp
	if (!$rtmp_server||$rtmp_server=="rtmp://youserver.com/vw/")
	{
		$message="A valid RTMP server needs to be configured in component or room parameters.";
		$loggedin=0;
		$visitor=0;
	}

	$message=urlencode($message);

	//limited
	if ($room->credits) $disconnectOnTimeout=1;	else $disconnectOnTimeout=0;

	//paths
	$host=$_SERVER['HTTP_HOST'];
	$path=$_SERVER['REQUEST_URI'];
	$lpath=strrchr($path, "/");
	if ($lpath) $path=substr($path,0,-strlen($lpath)+1);
	$apath=urlencode("http://".$host.$path);

	$userType=0;

	//admin
	$aroom_delete=0;
	$aroom_create=0;
	if ($administrator)
	{
	$userType=3;
	$aroom_delete=1;
	$aroom_create=1;
	};

	}

	return "server=".urlencode($rtmp_server)."&serverAMF=AMF3&room=".$room->room."&username=".$username."&userType=".$userType."&visitor=".$visitor."&loggedin=".$loggedin."&msg=$message&webserver=$apath&tutorial=$show_tutorial&room_delete=$aroom_delete&room_create=$aroom_create&file_upload=".$allow_fileupload."&file_delete=".$allow_filedelete."&administrator=".$administrator."&room_limit=".$room->capacity."&welcome=".urlencode($room->welcome)."&showTimer=1&showCredit=".$showcredit."&disconnectOnTimeout=".$disconnectOnTimeout."&camWidth=".$cam[0]."&camHeight=".$cam[1]."&camFPS=".$room->camfps."&camBandwidth=".$room->bandwidth."&bufferLive=0.4&bufferFull=0.4&bufferLivePlayback=0.1&bufferFullPlayback=0.4&showCamSettings=1&advancedCamSettings=1&camMaxBandwidth=" . $room->maxbandwidth . "&configureSource=" . $cam_source ."&disableVideo=" . $cam_novideo . "&disableSound=" . $cam_nosound . "&layoutCode=" . $layoutCode . urlencode($room->layout) . "&fillWindow=" . $room->fillwindow. "&filterRegex=" . $filterRegex . "&filterReplace=" . $filterReplace . "&loadstatus=1";
	break;

	case "rooms":
	$user =& JFactory::getUser();
	$username=$user->get('name');

	$query = "SELECT * FROM #__vw_rooms where (public=1 or owner='$username') order by room asc";
    $db->setQuery( $query );
  	$rows = $db->loadObjectList();

	//room xml output
	$res="<rooms>";
	foreach ($rows as $row) $res.="<room room_name=\"".htmlentities($row->room)."\" room_description=\"".htmlentities($row->welcome)."\" capacity=\"".$row->capacity."\" user_number=\"0\" ".($row->public?"":"private_room=\"1\"")." /> ";
	$res.="</rooms>";

	return $res;
	break;
	case "room_create":
	$sql="SELECT * FROM #__vw_rooms WHERE room='$landing_room'";
	$db->setQuery( $sql );
	$room = $db->loadObject();
		if ($room)
	{
	$owner=$room->owner;

	$user =& JFactory::getUser();
	$username=$user->get('name');
	$usertype=$user->usertype;
  $debug="";
	if (hasrights($username, $usertype, $owner, $room->admins))
		{
  	$query = "INSERT INTO `#__vw_rooms` (`room` ,`welcome` ,`public` ,`owner` ,`capacity` ,`timeexpire`) VALUES ('".JRequest::getVar( 'rname' )."', '".JRequest::getVar( 'rdescription' )."', '1', '$username', '".JRequest::getVar( 'rcapacity' )."', '".(JRequest::getVar( 'rexpires' ))."')";
    $db->setQuery( $query );
  	$db->query();
    $debug=urlencode($db->getErrorMsg());
		}
    else $debug="no-rights";
	}
	return "loadstatus=1&debug=$debug";
	break;
	case "room_delete":
	$sql="SELECT * FROM #__vw_rooms WHERE room='".JRequest::getVar( 'room' )."'";
	$db->setQuery( $sql );
	$room = $db->loadObject();
	if ($room)
	{
		$owner=$room->owner;

		$user =& JFactory::getUser();
		$username=$user->get('name');
		$usertype=$user->usertype;

		if (hasrights($username, $usertype, $owner, $room->admins))
		{
		$query = "DELETE FROM #__vw_rooms WHERE room='".JRequest::getVar( 'room' )."'";
    	$db->setQuery( $query );
  		$db->query();
		}
	}
	return "loadstatus=1";
	break;

	case "files":
	$room=JRequest::getVar( 'room' );

	$res="<files>";

	$dir=$path."uploads";
	$dir.="/$room";
	if (!file_exists($dir)) mkdir($dir);
	$handle=opendir($dir);
	while
	(($file = readdir($handle))!==false)
	{
	if (($file != ".") && ($file != "..") && (!is_dir("$dir/".$file))) $res.="<file file_name=\"".$file."\" file_size=\"".filesize("$dir/".$file)."\" />";
	}
	closedir($handle);
	$res.="</files>";
	return $res;
	break;

	case "upload":
	$room=JRequest::getVar( 'room' );
	$ext=substr($_FILES['vw_file']['name'],-4);
	$allowed=array(".zip",".jpg","jpeg",".png",".gif",".txt",".doc","docx",".htm","html",".pdf");

	//do not allow uploads to other folders
	if ( strstr($room,"..") ) exit;

	if (in_array($ext,$allowed)) move_uploaded_file($_FILES['vw_file']['tmp_name'], $path."uploads/".$room."/".$_FILES['vw_file']['name']);
	return "loadstatus=1";
	break;

	case "fdelete":
	$room=JRequest::getVar( 'room' );
	$filename=JRequest::getVar( 'filename' );

	//do not allow deletions in other folders
	if ( strstr($room,"..") ) exit;
	if ( strstr($filename,"..") ) exit;

	unlink($path."uploads/".$room."/".$filename);
	return "loadstatus=1";

	case "status":
	$room_name = JRequest::getVar( 'r' );
	$session= JRequest::getVar( 's' );
	$username= JRequest::getVar( 'u' );

	$currentTime=JRequest::getVar( 'ct' );
	$lastTime=JRequest::getVar( 'lt' );

	$maximumSessionTime=0;
	$disconnect="";

	$sql="SELECT * FROM #__vw_rooms WHERE room='$room_name'";
	$db->setQuery( $sql );
	$room = $db->loadObject();

	if (!$room)
	{
		$disconnect=urlencode("You were disconnected because room $room_name is missing!");
	}
	else
	{

	if ($room->credits) $maximumSessionTime = $room->credits * 60000;
	if (!$room->timeused) $room->timeused=0;

	//update room stream time
	$deltaTime=$currentTime-$lastTime;
	$time=time();
	$sql = "UPDATE #__vw_rooms SET timeused = timeused + $deltaTime, timelastaccess=$time WHERE room = '$room_name'";
    $db->setQuery( $sql );
  	$db->query();
	$room->timeused=$room->timeused+$deltaTime;
	}

	//update online users list
	$ztime=time();

	$sql = "SELECT * FROM `#__vw_online` where session='$session' and status='1'";
	$db->setQuery( $sql );
	$zsession = &$db->loadObject();
	if (!$zsession)
	{
	$sql="INSERT INTO `#__vw_online` ( `session`, `username`, `room`, `message`, `sdate`, `edate`, `status`, `type`) VALUES ('$session', '$username', '$room_name', '', $ztime, $ztime, 1, 1)";
    $db->setQuery( $sql );
  	$db->query();
	}
	else
	{
	$sql="UPDATE `#__vw_online` set edate=$ztime, room='$room_name', username='$username' where session='$session' and status='1'";
    $db->setQuery( $sql );
  	$db->query();
	}

	$exptime=$ztime-20;
	$sql="DELETE FROM `#__vw_online` WHERE edate < $exptime";
    $db->setQuery( $sql );
  	$db->query();

	return "timeTotal=$maximumSessionTime&timeUsed=".$room->timeused."&lastTime=$currentTime&disconnect=$disconnect&loadstatus=1&debug=$debug";
	break;
	case "chatlog":
	$room = JRequest::getVar( 'r' );
	$session= JRequest::getVar( 's' );
	$username= JRequest::getVar( 'u' );
	$message= JRequest::getVar( 'msg' );
	$time= JRequest::getVar( 'msgtime' );

	//do not allow uploads to other folders
	if ( strstr($room,"/") || strstr($room,"..") ) exit;
	$day=date("y-M-j",time());

	$dfile = fopen($path."uploads/$room/Log$day.html","a");
	fputs($dfile,$message."<BR>");
	fclose($dfile);

	//update online users list
	$ztime=time();

	$sql = "SELECT * FROM `#__vw_online`where session='$session' and status='1'";
	$db->setQuery( $sql );
	$zsession = &$db->loadObject();
	if (!$zsession)
	{
	$sql="INSERT INTO `#__vw_online` ( `session`, `username`, `room`, `message`, `sdate`, `edate`, `status`, `type`) VALUES ('$session', '$username', '$room', '$message', $ztime, $ztime, 1, 1)";
    $db->setQuery( $sql );
  	$db->query();
	}
	else
	{
	$sql="UPDATE `#__vw_online` set edate=$ztime, room='$room', message='$message', username='$username' where session='$session' and status='1'";
    $db->setQuery( $sql );
  	$db->query();
	}

	return "loadstatus=1";
	break;
	default:
	return "'$task' Not Supported";
	break;
	}

    }
}